function m_demo()
    % load MNIST partial data
    load('MNIST_49.mat', 'train4', 'train9', 'test4', 'test9');
    
    % split train data to train and validation data
    ranNums1 = randperm(size(train4,1));
    ranNums2 = randperm(size(train9,1));
    nTPC = 200; % # of train per class
    
    trainD = [train4(ranNums1(1:nTPC),:); train9(ranNums2(1:nTPC),:)]';
    trainLabel = [ones(nTPC,1); -ones(nTPC,1)];
    
    valiD = [train4(ranNums1(nTPC+1:end),:); train9(ranNums2(nTPC+1:end),:)]';
    valiLabel = [ones(size(train4,1) - nTPC,1); -ones(size(train9,1) - nTPC,1)];
    
    testD = [test4; test9]';
    testLabel = [ones(size(test4,1),1); -ones(size(test9, 1),1)];
    
    % Add artificial noisy features
    nNoisyFeat = 200; % no of noisy features
    trainD = appNoisyFeats(trainD, nNoisyFeat);
    valiD  = appNoisyFeats(valiD,  nNoisyFeat);
    testD  = appNoisyFeats(testD,  nNoisyFeat);
    
    
    C = 0.5;
    % find the most descriminative features
    [v, b, weights, featureIdxs, featureWeights] =  ml_minhSVM(trainD, trainLabel, C, 1);
    
    fprintf('==>Test result: normal SVM\n');
    m_test(trainD, trainLabel, ones(size(trainD, 1),1), C, testD, testLabel);  
    
    fprintf('==>Test result: weighted SVM\n');
    m_test(trainD(featureIdxs,:), trainLabel, featureWeights, C, testD(featureIdxs,:), testLabel);
    fprintf('# of active features: %d\n', length(featureIdxs));
    
% append noisy features
function Data = appNoisyFeats(Data, nNoisyFeat)    
    n = size(Data, 2);
    NoisyD = randn(nNoisyFeat, n);
    Data = [Data; NoisyD];
